/*************************************************
*                                                *
* SiTCP Bus Control Protocol                     *
*                                                *
* 2007/07/28 Tomohisa Uchida                     *
*                                                *
*************************************************/
int bcp(char* ipAddr, unsigned int port, struct bcp_header* sndHeader, char* sndData, char* rcvdBuf){

  struct timeval timeout;
  fd_set setSelect;
  
  /* Create a Socket */
#ifdef DEBUG
  puts("\nCreate socket...\n");
#endif

  int sock;
  int sndDataLen;

  sock = socket(AF_INET, SOCK_DGRAM, 0);

  struct sockaddr_in sitcpAddr;
  
  sitcpAddr.sin_family      = AF_INET;
  sitcpAddr.sin_port        = htons(port);
  sitcpAddr.sin_addr.s_addr = inet_addr(ipAddr);

  sndHeader->type=0xFF;
  sndHeader->id++;
  sndDataLen = (int)sndHeader->length;

#ifdef DEBUG
  printf(" Length = %i\n",sndDataLen);
#endif
	
  unsigned char sndBuf[2048];

  memcpy(sndBuf,sndHeader, sizeof(struct bcp_header));

  int i, j = 0;

#ifdef DEBUG
  for(i=0; i< sizeof(struct bcp_header);i++){
    if(j==0) {
      printf("\t[%.3x]:%.2x ",i,sndBuf[i]);
      j++;
    }else if(j==3){
      printf("%.2x\n",sndBuf[i]);
      j=0;
    }else{
      printf("%.2x ",sndBuf[i]);
      j++;
    }
  }
  puts("\n");
#endif

  if(sndHeader->command==0x80){
    sndDataLen = (int)sndHeader->length;
    memcpy(sndBuf+sizeof(struct bcp_header),sndData,sndDataLen);
  }else{
    sndDataLen = 0;
  }

#ifdef DEBUG
  for(i=0; i< sndDataLen + sizeof(struct bcp_header);i++){
    if(j==0) {
      printf("\t[%.3x]:%.2x ",i,sndBuf[i]);
      j++;
    }else if(j==3){
      printf("%.2x\n",sndBuf[i]);
      j=0;
    }else{
      printf("%.2x ",sndBuf[i]);
      j++;
    }
  }
  puts("\n");
#endif

  /* send a packet*/
  sendto(sock, sndBuf, sndDataLen + sizeof(struct bcp_header), 0, (struct sockaddr *)&sitcpAddr, sizeof(sitcpAddr));
#ifdef DEBUG
  puts("The 1st packet have been sent!");
#endif

#ifdef DEBUG
  puts("Wait to receive the ACK packet...");
#endif

  int numReTrans =0;
  int rcvdBytes;

  while(numReTrans<NUM_OF_RETRY){

    FD_ZERO(&setSelect);
    FD_SET(sock, &setSelect);

    timeout.tv_sec  = 0;
    timeout.tv_usec = 500000;
 
    if(select(sock+1, &setSelect, NULL, NULL,&timeout)==0){
      /* time out */
      /*
      puts("Wait to receive the ACK packet...");
      printf("***** # of Tx = %d *****\n",numReTrans);
      */
      printf("*");
      sndHeader->id++;
      memcpy(sndBuf,sndHeader, sizeof(struct bcp_header));
      sendto(sock, sndBuf, sndDataLen + sizeof(struct bcp_header), 0, (struct sockaddr *)&sitcpAddr, sizeof(sitcpAddr));
      numReTrans++;
      /*
      FD_ZERO(&setSelect);
      FD_SET(sock, &setSelect);
      */
    } else {
      /* receive packet */
      if(FD_ISSET(sock,&setSelect)){
	rcvdBytes=recvfrom(sock, rcvdBuf, 2048, 0, NULL, NULL);
	rcvdBuf[rcvdBytes]=0;
#ifdef DEBUG
	puts("\n***** A pacekt is received ! *****.");
	puts("Received data:");

	j=0;

	for(i=0; i<rcvdBytes; i++){
	  if(j==0) {
	    printf("\t[%.3x]:%.2x ",i,rcvdBuf[i]);
	    j++;
	  }else if(j==3){
	    printf("%.2x\n",rcvdBuf[i]);
	    j=0;
	  }else{
	    printf("%.2x ",rcvdBuf[i]);
	    j++;
	  }
	}
	puts("\n");
#endif
	numReTrans = NUM_OF_RETRY;
	close(sock);
	return(rcvdBytes);
      }
    }
  }
  close(sock);
  return -1;
}
